
lib_include "Sys/sys.l";

#define STEPS 1000000



lib_main {
    int i,sectab[STEPS],usectab[STEPS],hist[1000],h,hs;
    struct timeval tv;
    struct timezone tz;
    double t,t0,d;

    // record gettimeofday() samples
    for (i=0;i<STEPS;i++) {
        gettimeofday(&tv,&tz);
        sectab[i]=tv.tv_sec; usectab[i]=tv.tv_usec;
    }

    // print results
    for (h=0;h<1000;h++) hist[h]=0;
    hs=0;
    for (i=0;i<STEPS;i++) {
        t=(double)sectab[i]*1e6+(double)usectab[i];
        if (i>0) {
            d=t-t0; h=(int)floor(d+0.5);
            if (h>=1000) printf("long pause %d usec\n",h);
            else { hist[h]++; hs+=h; }
        }
        t0=t;
    }
    for (h=0;h<1000;h++) {
        if (hist[h]>0)
            printf("%3.3d usec: %5d [%g%%]\n",h,hist[h],
                (double)hist[h]*(double)h/(double)hs);
    }
};


